package com.test.poc.fromfile.foreach;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.jbpm.api.Configuration;
import org.jbpm.api.Execution;
import org.jbpm.api.ExecutionService;
import org.jbpm.api.IdentityService;
import org.jbpm.api.ManagementService;
import org.jbpm.api.ProcessEngine;
import org.jbpm.api.ProcessInstance;
import org.jbpm.api.RepositoryService;
import org.jbpm.api.TaskService;
import org.jbpm.api.job.Job;
import org.jbpm.api.task.Task;

public class PocRunner {
	public static void main (String [] args){
		
		System.out.println("This is PocRunner");
		String deploymentId;
		ProcessEngine processEngine = new Configuration()
	      .buildProcessEngine();
		
		RepositoryService repositoryService = processEngine.getRepositoryService();
		 
		// Deploy the process
		deploymentId = repositoryService.createDeployment()
	        .addResourceFromClasspath("com/test/poc/fromfile/foreach/process.jpdl.xml")
	        .deploy();

		//create the users
		
		IdentityService identysvc= processEngine.getIdentityService();
		
		String salesdept= identysvc.createGroup("sales");
		String clerkdept= identysvc.createGroup("clerk");
		String mgmtdept= identysvc.createGroup("management");
		 
		 
		identysvc.createUser("Alex", "Alex", "password");
		identysvc.createMembership("Alex", clerkdept);
		
		identysvc.createUser("Peter", "Peter", "password");
		identysvc.createMembership("Peter", salesdept);
	    
		identysvc.createUser("Mary", "Mary", "password");
		identysvc.createMembership("Mary", salesdept);
		
		
		
		identysvc.createUser("Mike", "Mike", "password");
		identysvc.createMembership("Mike", mgmtdept);
		
	
	    
	    ExecutionService executionService = processEngine.getExecutionService();
	    
	    Map<String, Object> variables = new HashMap<String, Object>(); 
		 variables.put("processengine", processEngine);
		ProcessInstance processInstance = executionService.startProcessInstanceByKey("SalesPocDynamic");
		
	
	    
System.out.println("process instance started by scheduler::");
		
		//Create Task Service
		TaskService taskService = processEngine.getTaskService();
		List<Task> taskList = taskService.findPersonalTasks("Alex");
		Task task = taskList.get(0);
		
		System.out.println("Task name of the pending task with Alex is ########      "+task.getName() );
		taskService.completeTask(task.getId());
		
		
		List<Task> taskListpen = taskService.findPersonalTasks("Alex");
		
		System.out.println("The number of tasks in Sue's inbox is now ##########   " +taskListpen.size() );
		System.out.println("Sales clerk sue completed the task, now task allocated to Sales group (Mary, Peter-- Sale manager role)");
		
		List<Task> tasks_peter = taskService.findGroupTasks("Peter");
		System.out.println("The number of group task for Suneetha is:::: " + tasks_peter.size());
		
		List<Task> tasks_mary = taskService.findGroupTasks("Mary");
		System.out.println("The number of group task for Mary is:::: " + tasks_mary.size());
		
		
		
		
		
		

		

	 try {
		Thread.sleep(3000);
	} catch (InterruptedException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
		
		
	}
	
	System.out.println("No one has claimed the Task, Peter allocates it to Mary");
	
	 Task task_peter = tasks_peter.get(0);
	 taskService.assignTask(task_peter.getId(), "Mary");
	 
	 System.out.println("Now the task is assigned to Mary");
	 
	 System.out.println("The following task is still with Mary ########### " +task_peter.getName());
		
	 List<Task> taskpersonalMary = taskService.findPersonalTasks("Mary");
		Task taskmppp = taskpersonalMary.get(0);
		taskService.completeTask(taskmppp.getId());
	 	    
		
		System.out.println("The task is completed by Mary..." +
				" now it will be allocated to users.. Mary, Peter and Alex");
		
		
		 try {
				Thread.sleep(7000);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				
				
			}
		List<Task> taskListpeter1 = taskService.findPersonalTasks("Peter");
		
		System.out.println("The number of tasks in Peter inbox is now ##########   " +taskListpeter1.size() );
		Task taskpeter1 = taskListpeter1.get(0);
		String taskDbid = taskpeter1.getId();
		Set<String> variableNames = taskService.getVariableNames(taskDbid);

		System.out.println("The variables are :::::"+taskService.getVariable(taskDbid, "workurl"));

		taskService.completeTask(taskpeter1.getId());
		
		
		List<Task> taskListMary1 = taskService.findPersonalTasks("Mary");
		
		System.out.println("The number of tasks in Mary's inbox is now ##########   " +taskListMary1.size() );
		Task taskMary1 = taskListMary1.get(0);
		
		String taskDbid1 = taskMary1.getId();
		Set<String> variableNames1 = taskService.getVariableNames(taskDbid1);

		System.out.println("The variables are :::::"+taskService.getVariable(taskDbid1, "workurl"));
		
		taskService.completeTask(taskMary1.getId());
		
		
		
		List<Task> taskListAlex1 = taskService.findPersonalTasks("Alex");
		
		System.out.println("The number of tasks in Alex inbox is now ##########   " +taskListAlex1.size() );
		Task taskAlex1 = taskListAlex1.get(0);
		taskService.completeTask(taskAlex1.getId());
		
		
	System.out.println( "All tasks are completed now");
	
	}
}
